/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.94 by jmc, Thu Sep 6 22:31:45 2007 UTC revision 1.111 by mlosch, Wed Feb 6 21:06:03 2008 UTC
# Line 15  usage() Line 15  usage()
15      echo "  (-mpi)                   compile and run using MPI"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18        echo "  (-gsl)                   compile with \"-gsl\" flag"
19      echo "  (-of=|-optfile=)STRING   list of optfiles to use"      echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"\" no email is sent)"
22      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
23      echo "                             (recognized groups: basic, tutorials)"      echo "                             (recognized groups: basic, tutorials)"
24      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
# Line 96  build_mpack() Line 97  build_mpack()
97    
98  testoutput_var()  testoutput_var()
99  {  {
100      # testoutput_var dir s1 label subdir extension      # testoutput_var dir s1 label subdir reference_output
101      #      #
102      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
103      #     with same output from reference file $dir/results/output.$extension      #     with same output from reference file $dir/results/$reference_output
104      #  using search strings s1 and text label      #  using search strings s1 and text label
105    
106      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
# Line 108  testoutput_var() Line 109  testoutput_var()
109      if [ -r $1/$4/$OUTPUTFILE ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
110          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
111          lncntA=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
112          if [ $lncntA -lt 3 ]; then          if [ $lncntA -lt 2 ]; then
113              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
114                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
115              fi              fi
# Line 119  testoutput_var() Line 120  testoutput_var()
120          return 99          return 99
121      fi      fi
122      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
123          echo testoutput_var: grep "$2" $1/results/output.$5 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
124      fi      fi
125      grep "$2" $1/results/output.$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
126      lncntB=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
127      if [ $lncntB -lt 3 ]; then      if [ $lncntB -lt 2 ]; then
128          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
129              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
130          fi          fi
# Line 161  testoutput_var() Line 162  testoutput_var()
162      digits_of_similarity=`./tr_cmpnum < tmp4.txt`      digits_of_similarity=`./tr_cmpnum < tmp4.txt`
163      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
164          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
165              echo testoutput_var: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
166          fi          fi
167          digits_of_similarity=99          digits_of_similarity=99
168      else      else
169          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
170              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
171          fi          fi
172      fi      fi
173      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
# Line 174  testoutput_var() Line 175  testoutput_var()
175      return $digits_of_similarity      return $digits_of_similarity
176  }  }
177    
 dashnum()  
 {  
     # dashnum n1 n2 n3 ...  
     #  
     #  print numbers using %3i format or "--" if number = 99  
   
     for num in $@ ; do  
         if [ $num = 99 ]; then  
             printf ' --'  
         else  
             printf '%3i' $num  
         fi  
     done  
 }  
   
 testoutput_ad()  
 {  
     grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $5}' > t05.txt  
     grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $5}' > t15.txt  
     grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $6}' > t06.txt  
     grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $6}' > t16.txt  
     join t05.txt t15.txt > t5.txt  
     join t06.txt t16.txt > t6.txt  
     echo "-1" >> t5.txt  
     echo "-1" >> t6.txt  
     digits_5=`./tr_cmpnum < t5.txt`  
     digits_6=`./tr_cmpnum < t6.txt`  
     dashnum $digits_5 $digits_6  
     rm -f t[01][56].txt t[56].txt  
 }  
   
178  check_for_add_mon_output()  check_for_add_mon_output()
179  {  {
180      # Check for additional types of monitor output      # Check for additional types of monitor output
# Line 232  check_for_add_mon_output() Line 202  check_for_add_mon_output()
202    
203  testoutput_run()  testoutput_run()
204  {  {
205      # testoutput_run directory subdir extension      # testoutput_run directory subdir reference_output
206      #      #
207      #  test output from 1 run in "directory"      #  test output from 1 run in "directory"
208      if test "x$ADM" = x ; then  # --> same processing for adjoint & forward test
209          # default list of output variables to be checked:          # default list of output variables to be checked:
210          #  1rst : main variable used to decide if it pass or FAIL          #  1rst : main variable used to decide if it pass or FAIL
211          #  others : number of matching digits to be printed in summary.txt          #  others : number of matching digits to be printed in summary.txt
212          listChk=$DEF_CHECK_LIST          listChk=$DEF_CHECK_LIST
         nbDef=`echo $listChk | awk '{print NF-1+3*gsub("+","E")}'`  
213          #  load experiment-specific list from file "tr_checklist" (if it exist)          #  load experiment-specific list from file "tr_checklist" (if it exist)
214          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
215          sVar=`echo $listChk | awk '{print $1}'`          sVar=`echo $listChk | awk '{print $1}'`
216          # remove 1rst var and expand the list: + => min max mean s.d          # remove 1rst var and expand the list: + => min max mean s.d
217          listVar=`echo $listChk | awk '{ for(i=2;i<=NF;i++){if (sub("+","",$i)) \          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
218              {printf " %s %s %s %s",$i"mn",$i"mx",$i"av",$i"sd"} else {printf " %s",$i} }}'`                                 | sed 's/+//g' | sed "s/^$sVar//"`
219          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
220          for ii in 1 2 3 4 5 6 7 8 9 ; do          for ii in 1 2 3 4 5 6 7 8 9 ; do
221            tst=`eval 'echo "$HAVE_PTR0'$ii'"'`            tst=`eval 'echo "$HAVE_PTR0'$ii'"'`
# Line 269  testoutput_run() Line 238  testoutput_run()
238            case $xx in            case $xx in
239             'PS')  if [ $debug -gt 0 ]             'PS')  if [ $debug -gt 0 ]
240                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
241                    testoutput_var $1 "cg2d_init_res" "cg2d init. residual" $2 $3; yy=$?                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
242                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
243             'Tmn') testoutput_var $1 "dynstat_theta_min"  "theta minimum"  $2 $3; yy=$? ;;            'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
244             'Tmx') testoutput_var $1 "dynstat_theta_max"  "theta maximum"  $2 $3; yy=$? ;;            'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
245             'Tav') testoutput_var $1 "dynstat_theta_mean" "theta mean"     $2 $3; yy=$? ;;             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
246             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "theta s.d."     $2 $3; yy=$? ;;             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
247             'Smn') testoutput_var $1 "dynstat_salt_min"  "salt minimum"    $2 $3; yy=$? ;;             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
248             'Smx') testoutput_var $1 "dynstat_salt_max"  "salt maximum"    $2 $3; yy=$? ;;             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
249             'Sav') testoutput_var $1 "dynstat_salt_mean" "salt mean"       $2 $3; yy=$? ;;             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
250             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "salt s.d."       $2 $3; yy=$? ;;             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
251               'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
252               'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
253             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
254             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
255             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
256             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U s.d."          $2 $3; yy=$? ;;             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
257             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
258             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
259             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
260             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V s.d."          $2 $3; yy=$? ;;             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
261          'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
262             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
263          'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
# Line 294  testoutput_run() Line 265  testoutput_run()
265          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
266             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
267          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
268             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_sd"    $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
269             'Qntmn') testoutput_var $1 "extforcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
270             'Qntmx') testoutput_var $1 "extforcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
271             'Qntav') testoutput_var $1 "extforcing_qnet_mean" "Qnet mean"    $2 $3; yy=$? ;;
272             'Qntsd') testoutput_var $1 "extforcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
273             'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
274             'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
275             'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
276             'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
277             'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
278             'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Hell max"   $2 $3; yy=$? ;;
279             'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Hell mean"  $2 $3; yy=$? ;;
280             'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Hell StDv"  $2 $3; yy=$? ;;
281            'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
282            'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
283            'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
284            'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;
285            'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;
286            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;
287                *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;                *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
288            esac            esac
289            if test $xx = $sVar            if test $xx = $sVar
# Line 304  testoutput_run() Line 293  testoutput_run()
293          done          done
294    
295          nbVar=`echo $listVar | awk '{print NF}'`          nbVar=`echo $listVar | awk '{print NF}'`
296          if [ $nbVar -lt $nbDef ] ; then          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
297          #-- fill line (up to standard length) with dot:          #-- fill line (up to standard length) with dot:
298            adNul=`expr $nbDef - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
299            echo $allargs $adNul            echo $allargs $adNul
300          else          else
301            echo $allargs            echo $allargs
302          fi          fi
303    # <-- same processing for adjoint & forward test
     else  
         testoutput_ad $1 $2 "precision_grdchk_result"  
     fi  
304  }  }
305    
306  genmakemodel()  genmakemodel()
# Line 342  genmakemodel() Line 328  genmakemodel()
328              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
329                  command="$command -ieee"                  command="$command -ieee"
330              fi              fi
331                if test "x$GSL" = xt ; then
332                    command="$command -gsl"
333                fi
334              if test "x$MPI" = xt ; then              if test "x$MPI" = xt ; then
335                  command="$command -mpi"                  command="$command -mpi"
336              fi              fi
# Line 414  run_clean() Line 403  run_clean()
403              find . -type l -exec rm {} \;              find . -type l -exec rm {} \;
404              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
405              rm -rf mnc_test_*              rm -rf mnc_test_*
406                rm -f *_MIT_CE_000.opt0000 costfunction*0000
407              echo successful 1>&2              echo successful 1>&2
408              exit 0              exit 0
409          )          )
# Line 484  symlink_mpifiles() Line 474  symlink_mpifiles()
474      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
475            
476      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
477      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
478    
479      #  Is this an MPI run?      #  Is this an MPI run?
480      if test "x$MPI" = xt ; then      if test "x$MPI" = xt ; then
# Line 542  linkdata() Line 532  linkdata()
532                      if test -h eedata ; then rm -f eedata ; fi                      if test -h eedata ; then rm -f eedata ; fi
533                  fi                  fi
534              fi              fi
535                prevDir='NONE'
536              for ldir in $* ; do              for ldir in $* ; do
537                  if test -d "../"$ldir ; then                  if test -d "../"$ldir -a $ldir != $prevDir ; then
538                      printf 'ldir='${ldir} 1>&2                      printf 'ldir='${ldir} 1>&2
539                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
540                      for i in $files ; do                      for i in $files ; do
# Line 559  linkdata() Line 550  linkdata()
550                      fi                      fi
551                      printf ' ; ' 1>&2                      printf ' ; ' 1>&2
552                  fi                  fi
553                    prevDir=$ldir
554              done              done
555          )          )
556      fi      fi
# Line 575  runmodel() Line 567  runmodel()
567          printf 'runmodel in %s ...' $1 1>&2          printf 'runmodel in %s ...' $1 1>&2
568          # make output.txt          # make output.txt
569          echo          echo
570            if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
571                diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
572                outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; rm -f run.log ; fi
573            fi
574          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
575              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00
576              ln -sf "../"$builddir"/"$EXECUTABLE .              ln -sf "../"$builddir"/"$EXECUTABLE .
# Line 586  runmodel() Line 582  runmodel()
582                  RETVAL=8                  RETVAL=8
583                  ENDVAL=-1                  ENDVAL=-1
584          else          else
585              if test $OUTPUTFILE -ot $EXECUTABLE ; then              if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
586                  # output do not exist or is older than executable:
587                  rm -f run.log ; touch run.log                  rm -f run.log ; touch run.log
588                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
589                  ( eval $COMMAND ) >> run.log 2>&1                  ( eval $COMMAND ) >> run.log 2>&1
# Line 637  int main( int argc, char** argv )  { Line 634  int main( int argc, char** argv )  {
634    double a,b,abave,relerr;    double a,b,abave,relerr;
635    best = -22;    best = -22;
636    lncnt = 0;    lncnt = 0;
637    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & ( (lncnt+=1) < 999 ) )  {
638      scanf("%d", &linnum);      scanf("%d", &linnum);
639      if (linnum == -1)  break;      if (linnum == -1)  break;
640      scanf("%lf", &a);  scanf("%lf", &b);      scanf("%lf", &a);  scanf("%lf", &b);
# Line 684  formatresults() Line 681  formatresults()
681      listPrt=$@      listPrt=$@
682      listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`      listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
683      xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`      xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
684      printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'      printf '%3s' $listPrt
685  #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > / /' | sed 's/  < / /'  #   line below does not work on hp-ux_ia64 : do those substitutions later on
686    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
687            
688      if [ $xx = '..' ]; then      if [ $xx = '..' ]; then
689          printf ' N/O '          printf ' N/O '
# Line 709  scandirs() Line 707  scandirs()
707  {  {
708      if [ $# -eq 1 ]; then      if [ $# -eq 1 ]; then
709          for arg in * ; do          for arg in * ; do
710              test -d $arg/$1 && echo $arg              test -f $arg/$1 && echo $arg
711          done          done
712      else      else
713          echo $*          echo $*
# Line 724  scandirs() Line 722  scandirs()
722  debug=0  debug=0
723  verbose=1  verbose=1
724  clean=0  clean=0
 expts=''  
 # ieee=1  
725    
726  IEEE=true  IEEE=true
727  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
728      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
729  fi  fi
730    GSL=f
731    
732  CLEANUP=f  CLEANUP=f
733  QUICK=f  QUICK=f
# Line 861  for ac_option ; do Line 857  for ac_option ; do
857    
858          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
859          -noieee) IEEE= ;;          -noieee) IEEE= ;;
860            -gsl) GSL=t ;;
861    
862          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
863          -debug) debug=1 ;;          -debug) debug=1 ;;
# Line 894  if test "x$QUICK" = xt ; then Line 891  if test "x$QUICK" = xt ; then
891      NODEPEND=t      NODEPEND=t
892  fi  fi
893    
894    #- setting for forward or ADM testing
895    if test "x$ADM" = xt ; then
896        code_dir=code_ad
897        inputdir=input_ad
898        ref_outp="output_adm.txt"
899        EXECUTABLE="mitgcmuv_ad"
900    else
901        code_dir=code
902        inputdir=input
903        ref_outp="output.txt"
904        EXECUTABLE="mitgcmuv"
905    fi
906    
907  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
908      if test "x$ADM" = xt ; then      LIST=`scandirs results/$ref_outp`
         LIST=`scandirs results_ad`  
     else  
         LIST=`scandirs results`  
     fi  
909  else  else
910      #- expand group of experiments:      #- expand group of experiments:
911      LIST=" "      LIST=" "
# Line 943  if test "x$OPTFILE" = xNONE -a "x$MITGCM Line 949  if test "x$OPTFILE" = xNONE -a "x$MITGCM
949      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
950  fi  fi
951    
952  if test "x$ADM" = xt ; then  OUTPUTFILE=$ref_outp
     EXECUTABLE="mitgcmuv_ad"  
     OUTPUTFILE="output_adm.txt"  
 else  
     EXECUTABLE="mitgcmuv"  
     OUTPUTFILE="output.txt"  
 fi  
   
953  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
954      COMMAND="./$EXECUTABLE > $OUTPUTFILE"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
955  fi  fi
# Line 958  if test "x$MPI" = xt ; then Line 957  if test "x$MPI" = xt ; then
957      OUTPUTFILE="STDOUT.0000"      OUTPUTFILE="STDOUT.0000"
958  fi  fi
959    
 #echo "OK"  
960  echo "OK (COMMAND= $COMMAND )"  echo "OK (COMMAND= $COMMAND )"
961    
962  # set the Default List of output variables to be checked:  # set the Default List of output variables to be checked:
963  #  (use default or load experiment-specific list from file "tr_checklist")  #  (use default or load experiment-specific list from file "tr_checklist")
964  # content : 1rst = main variable used to decide if it pass or FAIL  # content : 1rst = main variable used to decide if it pass or FAIL
965  #         others = number of matching digits to be printed in summary.txt  #         others = number of matching digits to be printed in summary.txt
966  if test "x$ADM" != xt ; then  if test "x$ADM" = x ; then
967      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
968      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
969      nbDef=`echo $DEF_CHECK_LIST | awk '{print NF-1+3*gsub("+","E")}'`      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
970      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
971      EMPTY_RESULTS=$EMPTY_RESULTS`expr $nbDef - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`      EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
972    else
973        DEF_CHECK_LIST='Grad Cost Grad'
974        EMPTY_RESULTS='.. ..'
975        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
976  fi  fi
977    
978  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
# Line 984  else Line 986  else
986  fi  fi
987    
988  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
989    CMDLINE=$0
990    for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
991  MACH=`hostname`  MACH=`hostname`
992  UNAMEA=`uname -a`  UNAMEA=`uname -a`
993  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
# Line 1004  if test "x$RETVAL" != x0 ; then Line 1008  if test "x$RETVAL" != x0 ; then
1008      exit 1      exit 1
1009  fi  fi
1010  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
 printf "Start time:  " >> $SUMMARY  
1011  start_date=`date`  start_date=`date`
1012  echo $start_date > $SUMMARY  echo $start_date > $SUMMARY
1013    echo 'run:' $CMDLINE >> $SUMMARY
1014    echo 'on :' $UNAMEA  >> $SUMMARY
1015    
1016  of_path=  of_path=
1017  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 1064  if test "x$ADM" = x ; then Line 1069  if test "x$ADM" = x ; then
1069  else  else
1070      echo "ADJOINT=true" >> $SUMMARY      echo "ADJOINT=true" >> $SUMMARY
1071      echo >> $SUMMARY      echo >> $SUMMARY
1072        if [ $MATCH_CRIT -lt 10 ] ;
1073        then line_0="default     "$MATCH_CRIT ;
1074        else line_0="default    "$MATCH_CRIT ; fi
1075        echo "$line_0" | tee -a $SUMMARY
1076      cat << EOF | tee -a $SUMMARY      cat << EOF | tee -a $SUMMARY
1077  G D M    C  G  G D M    C  G
1078  E p a R  o  r  E p a R  o  r
# Line 1076  fi Line 1085  fi
1085  #  ...and each test directory...  #  ...and each test directory...
1086  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1087            
1088        # set builddir & rundir:
1089        builddir="build"
1090        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1091        rundir="run"
1092        if test ! -d $dir/$rundir ; then
1093            rundir=$builddir
1094        fi
1095        CODE_DIR=$dir/$code_dir
1096        BUILD_DIR=$dir/$builddir
1097    
1098      #  Cleanup only!      #  Cleanup only!
1099      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1100          if test -r $dir/build/Makefile ; then          if test -r $BUILD_DIR/Makefile ; then
1101              echo '  ------  clean dir:' $dir/build              echo '  ------  clean dir:' $dir/build
1102              ( cd $dir/build ; make CLEAN )              ( cd $BUILD_DIR ; make CLEAN )
1103          fi          fi
1104          if test -d $dir/run/CVS ; then          if test -d $dir/$rundir/CVS ; then
1105              echo '  ------  clean dir:' $dir/run              echo '  ------  clean dir:' $dir/$rundir
1106              run_clean $dir/run              run_clean $dir/$rundir
1107          fi          fi
1108          (          (
1109              cd $dir              cd $dir
# Line 1095  for dir in $TESTDIRS ; do Line 1114  for dir in $TESTDIRS ; do
1114    
1115      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1116      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1117      fout=      fout=$dir"/results/"$ref_outp
     if test "x$ADM" = x ; then  
         fout=$dir"/results/output.txt"  
     else  
         fout=$dir"/results_ad/output_adm.txt"  
     fi  
1118      if test ! -r $fout ; then      if test ! -r $fout ; then
1119          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1120          continue          continue
# Line 1111  for dir in $TESTDIRS ; do Line 1125  for dir in $TESTDIRS ; do
1125    
1126      # Check for additional types of monitor output      # Check for additional types of monitor output
1127    
     builddir="build"  
     if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi  
     rundir="run"  
    #rundir=$builddir  
     if test ! -d $dir/$rundir ; then  
         rundir=$builddir  
     fi  
       
     if test "x$ADM" = x ; then  
         code_dir=code  
         CODE_DIR=$dir/code  
         input_dirs='input'  
     else  
         code_dir=code_ad  
         CODE_DIR=$dir/code_ad  
         input_dirs='input_ad input'  
     fi  
     BUILD_DIR=$dir/$builddir  
   
1128      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1129          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1130          continue          continue
# Line 1141  for dir in $TESTDIRS ; do Line 1136  for dir in $TESTDIRS ; do
1136    
1137      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1138      extra_runs=      extra_runs=
1139      if test "x$ADM" = x ; then      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1140          ex_run_dirs=`( cd $dir ; echo input.* )`      #echo "ex_run_dirs='$ex_run_dirs'"
1141          #echo "ex_run_dirs='$ex_run_dirs'"      for exd in $ex_run_dirs ; do
1142          for exd in $ex_run_dirs ; do          name=`echo $exd | sed -e "s/$inputdir\.//"`
1143              name=`echo $exd | sed -e 's/input.//g'`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1144              outf="$dir/results/output.$name.txt"          outf="$dir/results/$refExOut"
1145              if test -f $outf -a -r $outf ; then          if test -f $outf -a -r $outf ; then
1146                  if test "x$MULTI_THREAD" = "xt" ; then              if test "x$MULTI_THREAD" = "xt" ; then
1147                      if test -r $dir"/"$exd"/eedata.mth" ; then                  if test -r $dir"/"$exd"/eedata.mth" ; then
                         extra_runs="$extra_runs $name"  
                     #else echo $dir"/"$exd"/eedata.mth: not found"  
                     fi  
                 else  
1148                      extra_runs="$extra_runs $name"                      extra_runs="$extra_runs $name"
1149                    #else echo $dir"/"$exd"/eedata.mth: not found"
1150                  fi                  fi
1151                else
1152                    extra_runs="$extra_runs $name"
1153              fi              fi
1154          done          fi
1155      fi      done
1156    
1157      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1158      echo      echo
# Line 1187  for dir in $TESTDIRS ; do Line 1181  for dir in $TESTDIRS ; do
1181              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1182              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1183              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1184              && linkdata $dir/$rundir $input_dirs \              && linkdata $dir/$rundir $inputdir input \
1185              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1186              && results=`testoutput_run $dir $rundir "txt"`              && results=`testoutput_run $dir $rundir $ref_outp`
1187      fi      fi
1188            
1189      echo      echo
     if test "x$ADM" = x ; then  
1190          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1191          echo          echo
1192          echo "$fres" >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1193          touch $CDIR"/summary.txt"          touch $CDIR"/summary.txt"
1194          echo "fresults='$fres'" >> $CDIR"/summary.txt"          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1195          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1196          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1197          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1198          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1199            if test "x$ADM" = xt ; then
1200                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1201                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1202                                    >> $CDIR"/summary.txt"
1203            fi
1204    
1205          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1206              unset run              unset run
1207              results=$EMPTY_RESULTS              results=$EMPTY_RESULTS
1208                #  reference output file
1209                refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1210              #  Create an output dir for each OPTFILE/tdir.ex combination              #  Create an output dir for each OPTFILE/tdir.ex combination
1211              rel_CDIR=$DRESULTS"/"$dir"."$ex              rel_CDIR=$DRESULTS"/"$dir"."$ex
1212              mkdir $rel_CDIR              mkdir $rel_CDIR
1213              CDIR=`pwd`"/$rel_CDIR"              CDIR=`pwd`"/$rel_CDIR"
1214              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1215              run_clean $dir/tr_run.$ex              run_clean $dir/tr_run.$ex
1216              linkdata $dir/tr_run.$ex input.$ex input              linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
1217              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1218                  && results=`testoutput_run $dir tr_run.$ex ${ex}".txt"`              && results=`testoutput_run $dir tr_run.$ex $refExOut`
             fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
1219              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1220              fres="$fres.$ex"              fres="$fres.$ex"
1221              echo              echo
1222              echo "$fres" >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1223              touch $CDIR"/summary.txt"              touch $CDIR"/summary.txt"
1224              echo "fresults='$fres'" >> $CDIR"/summary.txt"              echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1225              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1226              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1227              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1228              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1229                if test "x$ADM" = xt ; then
1230                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1231                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1232                                       >> $CDIR"/summary.txt"
1233                fi
1234              if test "x$POSTCLEAN" = xt ; then              if test "x$POSTCLEAN" = xt ; then
1235                  run_clean $dir/tr_run.$ex                  run_clean $dir/tr_run.$ex
1236              fi              fi
1237          done          done
     else  
         fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
         fres=$fres"$results   $dir"  
         echo  
         echo "$fres" >> $SUMMARY  
         touch $CDIR"/summary.txt"  
         echo "fresults='$fres'" >> $CDIR"/summary.txt"  
         echo "MACH='$MACH'" >> $CDIR"/summary.txt"  
         echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"  
         echo "DATE='$DATE'" >> $CDIR"/summary.txt"  
         echo "tdir='$dir'" >> $CDIR"/summary.txt"  
         grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \  
                            >> $CDIR"/summary.txt"  
     fi  
1238    
1239      #postclean $dir/$builddir      #postclean $dir/$builddir
1240      if test "x$POSTCLEAN" = xt ; then      if test "x$POSTCLEAN" = xt ; then
# Line 1291  fi Line 1281  fi
1281  rm -f tr_cmpnum.c tr_cmpnum  rm -f tr_cmpnum.c tr_cmpnum
1282    
1283  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1284      cat $SUMMARY | sed 's/  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.//'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
 #   cat $SUMMARY | sed 's/  \.//g'  
1285      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1286          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1287      fi      fi
1288      cat $SUMMARY | sed 's/  \.//g' > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1289  fi  fi
1290    
1291  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.94  
changed lines
  Added in v.1.111

  ViewVC Help
Powered by ViewVC 1.1.22